package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description :
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-23 15:53
 * @Modify:
 **/
public class WmsEnumUtil {
    /**
     * PO订单明细信息 是否免费
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum IS_FREE {
        CHARGING(0, "计费"), GRATIS(1, "免费");

        private int value;
        private String description;

        private IS_FREE(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * PO订单明细信息 状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_DETAILS_STATUS {
        NORMAL(10, "N", "正常"),
        ANCEL(20, "C", "行取消");

        private int value;
        private String code;
        private String description;

        private ORDER_DETAILS_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * PO主表信息 单据来源
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PO_ORDER_SRC {
        MNU(1, "MNU", "手工"),
        ERP(2, "ERP", "ERP接口");

        private int value;
        private String code;
        private String description;

        private PO_ORDER_SRC(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }
    /**
     * PO主表信息 单据类型
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum PO_ORDER_TYPE {
        REG(1, "REG", "原物料采购"),
        SUB(10, "SUB", "委外采购"),
        TAR(20, "TAR", "多角贸易采购"),
        TAP(30, "TAP", "多角代采购");

        private int value;
        private String code;
        private String description;

        private PO_ORDER_TYPE(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * PO主表信息 状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORDER_STATUS {
        CREATE(0, "新建"),
        RECEIPT(10, "收货中"),
        RECEIPT_FINISH(20, "收货完成"),
        WAREHOUSING(30, "入库中"),
        WAREHOUSING_FINISH(40, "入库完成"),
        CLOSED(90, "已关闭"),
        CANCELLED(91, "已取消");

        private int value;
        private String description;

        private ORDER_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 交易状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TRANS_STATUS {
        CREATE(1, "创建"), FINISH(2, "完成"),FAIL(3,"失败");

        private int value;
        private String description;

        private TRANS_STATUS(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 消息队列，队列名称
     * 1: success_queue
     * 2: fail_queue
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum QUEUE_NAME{

        SUCCESS_QUEUE(1,"success_queue","成功消息队列"),
        FAIL_QUEUE(2,"fail_queue","成功消息队列");

        private int value;
        private String name;
        private String description;

        QUEUE_NAME() {
        }

        QUEUE_NAME(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * ASN单据类型
     */
    public enum ASN_ORDER_TYPE{

        REG("REG","原物料采购"),SUB("SUB","委外采购"),TAR("TAR","多角贸易采购"),TAP("TAP","多角代采购");

        private String value;
        private String description;

        ASN_ORDER_TYPE(String value, String description) {
            this.value = value;
            this.description = description;
        }

        public String getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(String val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * ASN明细表状态
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ASN_MASTER_ORDER_STATUS {
        NORMAL(1, "N", "正常"),
        CANCEL(2, "C", "行取消"),
        RECEIPTED(3, "R", "已收货");

        private int value;
        private String code;
        private String description;

        private ASN_MASTER_ORDER_STATUS(int value, String code, String description) {
            this.value = value;
            this.code = code;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public String getCode() {
            return code;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int descOf(String desc) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].description.equals(desc)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }
    }

    /**
     * 是否已删除
     */
    public enum IS_DELETED {
        DELETED(1, "已删除"), INDELETED(2, "未删除");

        private int value;
        private String description;

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        IS_DELETED(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public static String valueOf(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

}
