package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.text.DecimalFormat;

/**
 * @Description : 系统消息
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.689
 * @Modify      :
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="SYS_MESSAGE")
@Api(value="系统消息",description = "系统消息")
public class SysMessage extends BaseBean {

    @Column(name="MESSAGE_TITLE")
    @ApiParam(value ="消息标题" , access ="消息标题")
    private String messageTitle;
 
    @Column(name="MESSAGE_TYPE_ID")
    @ApiParam(value ="消息类型(枚举：1.通知，2.站内信)" , example ="-1")
    private Integer messageTypeId;

    @Column(name="MESSAGE_SEND_ID")
    @ApiParam(value ="发送者id" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long messageSendId;

    public Long getMessageSendId() {
        if(messageSendId != null) {
            return messageSendId.longValue();
        }else{
            return messageSendId;
        }
    }

    @Column(name="RED_SEND_NAME")
    @ApiParam(value ="发送者名称" )
    @JsonSerialize(using = ToStringSerializer.class)
    private String redSendName;
 
    @Column(name="MESSAGE_RECIPIENT_ID")
    @ApiParam(value ="接收者id"  , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long messageRecipientId;

    public Long getMessageRecipientId() {
        if(messageRecipientId != null) {
            return messageRecipientId.longValue();
        }else{
            return messageRecipientId;
        }
    }

    @Column(name="RED_MESSAGE_RECIPIENT_NAME")
    @ApiParam(value ="接收者名称"  , example = "0")
    @JsonSerialize(using = ToStringSerializer.class)
    private String redMessageRecipientName;

    @Column(name="MESSAGE_CONTENT")
    @ApiParam(value ="消息内容" , access ="消息内容")
    private String messageContent;
 
    @Column(name="MESSAGE_STATUS_ID")
    @ApiParam(value ="消息状态（枚举：1.已读，2.未读）" , example ="-1")
    private Integer messageStatusId;

}
