package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 用户登陆表
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-11 11:02
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="SYS_ROLE")
@Api(value="用户角色表",description = "用户权限角色。")
public class SysRole extends BaseBean {

    @Column(name="NAME")
    @ApiParam(value ="角色名称")
    private String name;

    @Column(name="ROLE_DESCRIPTION")
    @ApiParam(value ="资源描述")
    private String roleDescription;

    @Column(name="ROLE_GRADE")
    @ApiParam(value ="角色等级（待定）" , example ="-1")
    private Integer roleGrade;

    @Column(name="PARENT_ID")
    @ApiParam(value ="角色父节点ID" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long parentId;

    public Long getParentId() {
        if(parentId != null) {
            return parentId.longValue();
        }else{
            return parentId;
        }
    }

    @Column(name="RED_PARENT_NAME")
    @ApiParam(value ="角色父节点名称" , access ="角色父节点名称")
    private String redParentName;

    @Column(name="RED_MODULE_NAMES")
    @ApiParam(value ="权限模块名称" , access ="权限模块名称")
    private String redModuleNames;

    @Column(name="RED_MODULE_NUMBER")
    @ApiParam(value ="权限模块数量" , example ="0" , access ="权限模块数量")
    private Integer redModuleNumber;

    @Column(name="RED_MENU_NAMES")
    @ApiParam(value ="权限功能名称" , access ="权限功能名称")
    private String redMenuNames;

    @Column(name="RED_MENU_NUMBER")
    @ApiParam(value ="权限功能数量" , example ="0" , access ="权限功能数量")
    private Integer redMenuNumber;

    @Column(name="ROLE_STATUS_ID")
    @ApiParam(value ="角色状态（枚举：1.正常，2.状态）" , example ="-1")
    private Integer roleStatusId;

}
