package cn.estsh.i3plus.pojo.platform.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.text.DecimalFormat;

/**
 * @Description : 定时任务
 * @Reference   :
 * @Author      : wei.peng
 * @Date        : 2018-10-22 16:58:43.952
 * @Modify      :
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="TASK_TIME")
@Api(value="定时任务",description = "定时任务")
public class TaskTime extends BaseBean {

    @Column(name="NAME")
    @ApiParam(value ="名称")
    private String name;

    @Column(name="GROUP_NAME")
    @ApiParam(value ="名称")
    private String groupName;

    @Column(name="TIME_ID")
    @ApiParam(value ="时间表达式ID" , example = "-1")
    @JsonSerialize(using = ToStringSerializer.class)
    private Long timeId;

    public Long getTimeId() {
        if(timeId != null) {
            return timeId.longValue();
        }else{
            return timeId;
        }
    }

    @Column(name="RED_TIME_NAME")
    @ApiParam(value ="时间表达式名称")
    private String redTimeName;

    @Column(name="RED_TIME_EXPRESSION")
    @ApiParam(value ="时间表达式")
    private String redTimeExpression;

    @Column(name="TASK_START_DATE_TIME")
    @ApiParam(value ="任务开始时间")
    private String taskStartDateTime;

    @Column(name="TASK_END_DATE_TIME")
    @ApiParam(value ="任务结束时间")
    private String taskEndDateTime;

    @Column(name="TASK_NUM_SUM")
    @ApiParam(value ="执行总次数" , example ="0")
    private Integer taskNumSum;

    @Column(name="TASK_NUM_RUN")
    @ApiParam(value ="执行次数" , example ="0")
    private Integer taskNumRun;

    @Column(name="TASK_TYPE_ID")
    @ApiParam(value ="任务类型（枚举：1.定时任务）" , example ="-1")
    private Integer taskTypeId;

    @Column(name="TASK_METHOD")
    @ApiParam(value ="执行方法")
    private String taskMethod;

    @Column(name="TASK_METHOD_TYPE_ID")
    @ApiParam(value ="任务执行类型" ,example = "-1")
    private Integer taskMethodTypeId;

    @Column(name="TASK_DESCRIPTION")
    @ApiParam(value ="任务描述" , access ="任务描述")
    private String taskDescription;

    @Column(name="TASK_STATUS")
    @ApiParam(value ="任务状态（1.正常，2.禁用）" , example ="1")
    private Integer taskStatus;

    @Column(name="LAST_RUN_DATE_TIME")
    @ApiParam(value ="最后运行时间" , access ="最后运行时间")
    private String lastRunDateTime;

}
