package cn.estsh.i3plus.pojo.platform.sqlpack;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.platform.bean.*;

import java.util.Arrays;

/**
 * @Description : 平台对象封装
 * @Reference :
 * @Author : alwaysfrin
 * @CreateDate : 2018-10-23 21:15
 * @Modify:
 **/
public class CoreHqlPack {

    /**
     * 资源查询
     * @param sysLocaleResource
     * @return
     */
    public static String packHqlSysLocaleResource(SysLocaleResource sysLocaleResource){
        StringBuffer result = new StringBuffer();

        //查询日期
//        HqlPack.timeBuilder(sysLocaleResource.getCreateDateTimeStart(),sysLocaleResource.getCreateDateTimeEnd(),
//                "createDateTime", result, false);
        //数字类型封装
        HqlPack.getNumEqualPack(sysLocaleResource.getResourceType(),"resourceType",result);
        //字符串类型封装
        HqlPack.getStringEqualPack(sysLocaleResource.getLanguageCode(),"languageCode",result);
        //字符串类型封装
        HqlPack.getStringLikerPack(sysLocaleResource.getResourceKey(),"resourceKey",result);

        return result.toString();
    }

    /**
     * 语言
     * @param lang
     * @return
     */
    public static String packHqlSysLocaleLanguage(SysLocaleLanguage lang) {
        StringBuffer result = new StringBuffer();

        //查询日期
//        HqlPack.timeBuilder(lang.getCreateDateTimeStart(),lang.getCreateDateTimeEnd(),
//                "createDateTime", result, false);
        //字符串类型封装
        HqlPack.getStringLikerPack(lang.getLanguageCode(),"languageCode",result);
        //字符串类型封装
        HqlPack.getStringLikerPack(lang.getLanguageName(),"languageName",result);

        return result.toString();
    }

    /**
     * In 参数封装
     * @param columnName
     * @return
     */
    public static String packHqlIds(String columnName,String[] params){
        StringBuffer result =  new StringBuffer();

        // 参数数组 [1,2,3] -> "1,2,3"
        HqlPack.getInPack(String.join(",",params),columnName,result);
        return result.toString();
    }

    /**
     * 岗位复杂查询
     * @param position
     * @return
     */
    public static String packHqlPosition(Position position){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(position.getParentId(),"parentId",result);
        HqlPack.getStringLikerPack(position.getName(),"name",result);
        HqlPack.getStringLikerPack(position.getPositionCode(),"positionCode",result);

        return result.toString();
    }

    /**
     * 组织复杂查询
     * @param organize
     * @return
     */
    public static String packHqlOrganize(Organize organize){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(organize.getParentId(),"parentId",result);
        HqlPack.getStringLikerPack(organize.getName(),"name",result);
        HqlPack.getStringLikerPack(organize.getOrganizeCode(),"organizeCode",result);

        return result.toString();
    }

    /**
     * 部门复杂查询
     * @param department
     * @return
     */
    public static String packHqlDepartment(Department department){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(department.getParentId(),"parentId",result);
        HqlPack.getStringLikerPack(department.getName(),"name",result);
        HqlPack.getStringLikerPack(department.getDepartmentCode(),"departmentCode",result);

        return result.toString();
    }

    /**
     * 系统权限复杂查询
     * @param menu
     * @return
     */
    public static String packHqlSysMenu(SysMenu menu){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(menu.getParentId(),"parentId",result);
        HqlPack.getNumEqualPack(menu.getMenuStatus(),"menuStatus",result);
        HqlPack.getStringLikerPack(menu.getName(),"name",result);
        HqlPack.getStringLikerPack(menu.getMenuCode(),"menuCode",result);

        return result.toString();
    }

    /**
     * 系统角色复杂查询
     * @param role
     * @return
     */
    public static String packHqlSysRole(SysRole role){
        StringBuffer result = new StringBuffer();

        // 查询参数封装
        HqlPack.getNumEqualPack(role.getRoleStatusId(),"roleStatusId",result);
        HqlPack.getStringLikerPack(role.getName(),"name",result);

        return result.toString();
    }

    /**
     * 系统参数复杂查询
     * @param sysConfig
     * @return
     */
    public static String packHqlSysConfig(SysConfig sysConfig) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(sysConfig.getName(),"name",result);
        HqlPack.getStringLikerPack(sysConfig.getConfigCode(),"configCode",result);
        HqlPack.getNumEqualPack(sysConfig.getConfigTypeId(),"configTypeId",result);

        return result.toString();
    }

    /**
     * 字典信息复杂查询
     * @param sysDictionary
     * @return
     */
    public static String packHqlSysDictionary(SysDictionary sysDictionary) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(sysDictionary.getName(),"name",result);
        HqlPack.getStringLikerPack(sysDictionary.getDictionaryCode(),"dictionaryCode",result);
        // 默认查询非顶级字典
        if(sysDictionary.getParentId() == null || sysDictionary.getParentId() < 1){
            HqlPack.getNumNOEqualPack(CommonEnumUtil.PARENT.DEFAULT.getValue(),"parentId",result);
        }
        HqlPack.getNumEqualPack(sysDictionary.getParentId(),"parentId",result);

        return result.toString();
    }

    /**
     * 硬件类型复杂查询
     * @param toolType
     * @return
     */
    public static String packHqlToolType(ToolType toolType) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(toolType.getName(),"name",result);

        return result.toString();
    }

    /**
     * 硬件复杂查询
     * @param tool
     * @return
     */
    public static String packHqlTool(Tool tool) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(tool.getName(),"name",result);
        HqlPack.getNumEqualPack(tool.getToolTypeId(),"toolTypeId",result);
        HqlPack.getNumEqualPack(tool.getToolStatusId(),"toolStatusId",result);
        HqlPack.getNumEqualPack(tool.getToolDataTypeId(),"toolDataTypeId",result);
        HqlPack.getNumEqualPack(tool.getToolConnTypeId(),"toolConnTypeId",result);
        HqlPack.getStringLikerPack(tool.getToolIp(),"toolIp",result);
        HqlPack.getNumLikerPack(tool.getToolPort(),"toolPort",result);

        return result.toString();
    }

    /**
     * 消息复杂查询
     * @param sysMessage
     * @return
     */
    public static String packHqlSysMessage(SysMessage sysMessage){
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(sysMessage.getMessageTitle(),"messageTitle",result);
        HqlPack.getStringLikerPack(sysMessage.getMessageContent(),"messageContent",result);
        HqlPack.getNumLikerPack(sysMessage.getMessageStatusId(),"messageStatusId",result);
        HqlPack.getNumLikerPack(sysMessage.getMessageTypeId(),"messageTypeId",result);
        HqlPack.getNumEqualPack(sysMessage.getMessageRecipientId(),"messageRecipientId",result);
        HqlPack.getNumEqualPack(sysMessage.getMessageSendId(),"messageSendId",result);
        HqlPack.timeBuilder(sysMessage.getCreateDatetime(),"createDatetime", result, false,false);

        return  result.toString();
    }

    /**
     * 文件资源复杂查询
     * @param sysFile
     * @return
     */
    public static String packHqlSysFile(SysFile sysFile) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(sysFile.getName(),"name",result);
        HqlPack.getNumEqualPack(sysFile.getFileTypeId(),"fileTypeId",result);
        HqlPack.getStringLikerPack(sysFile.getCreateUser(),"createUser",result);
        HqlPack.timeBuilder(sysFile.getCreateDatetime(),"createDatetime",result,false,false);

        return  result.toString();
    }

    /**
     * 任务表达式复杂查询
     * @param taskTimeExpression
     * @return
     */
    public static String packHqlTaskTimeExpression(TaskTimeExpression taskTimeExpression) {
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(taskTimeExpression.getName(),"name",result);

        return  result.toString();
    }

    /**
     * 定时任务复杂查询
     * @param taskTime
     * @return
     */
    public static String packHqlTaskTime(TaskTime taskTime){
        StringBuffer result = new StringBuffer();

        // hql拼接
        HqlPack.getStringLikerPack(taskTime.getName(),"name",result);
        HqlPack.getNumEqualPack(taskTime.getTaskStatus(),"taskStatus",result);
        HqlPack.getNumEqualPack(taskTime.getTimeId(),"timeId",result);

        return  result.toString();
    }

    /**
     * 账号复杂查询
     * @param user
     * @return
     */
    public static String packHqlSysUser(SysUser user){
        StringBuffer result = new StringBuffer();

        // And X = X
        HqlPack.getNumEqualPack(user.getIsValid(),"isValid",result);
        HqlPack.getNumEqualPack(user.getDepartmentId(),"departmentId",result);
        HqlPack.getNumEqualPack(user.getRoleId(),"roleId",result);
        // And Like % %
        HqlPack.getStringLikerPack(user.getUserName(),"userName",result);
        HqlPack.getStringLikerPack(user.getUserLoginName(),"userLoginName",result);
        HqlPack.getStringLikerPack(user.getUserEmail(),"userEmail",result);
        HqlPack.getStringLikerPack(user.getUserPhone(),"userPhone",result);

        return  result.toString();
    }

    /**
     * 查询字典代码是否重复
     * @param sysDictionary
     * @return
     */
    public static String packHqlSysDictionaryCode(SysDictionary sysDictionary){
        StringBuffer result = new StringBuffer();

        // and
        HqlPack.getStringEqualPack(sysDictionary.getDictionaryCode(),"dictionaryCode",result);
        // not
        HqlPack.getNumNOEqualPack(sysDictionary.getId(),"id",result);

        return result.toString();
    }

    /**
     * 用户信息 复杂查询拼接
     * @param userInfo
     * @return
     */
    public static String packHqlSysUserInfo(SysUserInfo userInfo){
        StringBuffer result = new StringBuffer();

        // And
        HqlPack.getNumEqualPack(userInfo.getDepartmentId(),"departmentId",result);
        HqlPack.getNumEqualPack(userInfo.getPositionId(),"positionId",result);
        HqlPack.getNumEqualPack(userInfo.getUserInfoStatus(),"userInfoStatus",result);

        // Like
        HqlPack.getStringLikerPack(userInfo.getName(),"name",result);
        HqlPack.getStringLikerPack(userInfo.getUserEmpNo(),"userEmpNo",result);

        return  result.toString();
    }

    /**
     * 查询语言代码是否重复
     * @param sysLocaleLanguage
     * @return
     */
    public static String packHqlSysLocaleLanguageCode(SysLocaleLanguage sysLocaleLanguage){
        StringBuffer result = new StringBuffer();

        HqlPack.getStringEqualPack(sysLocaleLanguage.getLanguageCode(),"languageCode",result);
        HqlPack.getNumNOEqualPack(sysLocaleLanguage.getId(),"id",result);

        return result.toString();
    }

    /**
     * 检查系统资源是否重复
     * @param sysLocaleResource
     * @return
     */
    public static String packHqlSysLocaleResourceKey(SysLocaleResource sysLocaleResource){
        StringBuffer result = new StringBuffer();

        HqlPack.getStringEqualPack(sysLocaleResource.getLanguageCode(),"languageCode",result);
        HqlPack.getStringEqualPack(sysLocaleResource.getResourceKey(),"resourceKey",result);
        HqlPack.getNumNOEqualPack(sysLocaleResource.getId(),"id",result);

        return result.toString();
    }
}