package cn.estsh.i3plus.pojo.wms.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description : 产品发运信息
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-11-06 15:58
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="WMS_DOC_SHIPPING")
@Api("产品发运信息")
public class WmsShopping extends BaseBean {

    @Column(name="ORDER_NO")
    @ApiParam("发运单号")
    public String orderNo;

    @Column(name="PART_NO")
    @ApiParam("物料编码")
    public String partNo;

    @Column(name="PART_NAME_RDD")
    @ApiParam("物料名称")
    public String partNameRdd;

    @Column(name="QTY")
    @ApiParam(value = "需求数量", example = "0")
    public Double qty;

    @Column(name="UNIT")
    @ApiParam("单位")
    public String unit;

    @Column(name="SN")
    @ApiParam("条码")
    public String sn;

    /**
     * 状态:10=新建,20=已处理,30=处理出错
     */
    @Column(name="ORDER_STATUS")
    @ApiParam(value = "状态", example = "10")
    public Integer orderStatus;

    @Column(name="REMARK")
    @ApiParam("备注")
    public String reMark;

    @Column(name="SRC")
    @ApiParam("单据来源")
    public String src;

    @Column(name="CUST_NO")
    @ApiParam("客户编码")
    public String custNo;

    @Column(name="SHIPPING_FLAG")
    @ApiParam("特殊发货标志")
    public String shippingFlag;

    @ApiParam(value ="客户简称")
    private transient String custName;
}
