package cn.estsh.i3plus.pojo.wms.sqlpack;

import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.enumutil.WmsEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.HqlPack;
import cn.estsh.i3plus.pojo.wms.bean.*;

/**
 * @Description : 仓库管理对象封装
 * @Reference :
 * @Author : silliter.yuan
 * @CreateDate : 2018-10-31 10:45
 * @Modify:
 **/
public class WmsHqlPack {
    /**
     * PO订单明细表 分页查询
     *
     * @param wmsPOMasterDetails
     * @return
     */
    public static String packHqlWmsPOMasterDetails(WmsPOMasterDetails wmsPOMasterDetails) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsPOMasterDetails.getOrderNo(), "orderNo", result);
        HqlPack.getStringLikerPack(wmsPOMasterDetails.getItem(), "item", result);
        HqlPack.getStringLikerPack(wmsPOMasterDetails.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsPOMasterDetails.getPartNameRdd(), "partNameRdd", result);
        HqlPack.getStringLikerPack(wmsPOMasterDetails.getZTime(), "zTime", result);
        HqlPack.getStringLikerPack(wmsPOMasterDetails.getZDate(), "zDate", result);
        HqlPack.getNumEqualPack(wmsPOMasterDetails.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(wmsPOMasterDetails.getIsDeleted(), "isDeleted", result);
        HqlPack.getStringEqualPack(wmsPOMasterDetails.getOrganizeCode(), "organizeCode", result);

        return result.toString();
    }

    /**
     * 库存移动单详情查询封装
     *
     * @param wmsDocMovementDetails
     * @return
     */
    public static String packWmsDocMovementDetails(WmsDocMovementDetails wmsDocMovementDetails) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsDocMovementDetails.getOrderNo(), "orderNo", result);

        HqlPack.getNumEqualPack(CommonEnumUtil.IS_VAILD.VAILD.getValue(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                "isDeleted", result);
        return result.toString();
    }

    /**
     * 库存移动单查询封装
     *
     * @param wmsDocMovementMaster
     * @return
     */
    public static String packWmsDocMovementMaster(WmsDocMovementMaster wmsDocMovementMaster) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsDocMovementMaster.getOrderNo(), "orderNo", result);
        HqlPack.getNumEqualPack(wmsDocMovementMaster.getMoveType(), "moveType", result);
        HqlPack.getNumEqualPack(wmsDocMovementMaster.getBusiType(), "busiType", result);
        HqlPack.getStringLikerPack(wmsDocMovementMaster.getCustomerNo(), "customerNo", result);

        HqlPack.getStringEqualPack(wmsDocMovementMaster.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(wmsDocMovementMaster.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                "isDeleted", result);
        return result.toString();
    }

    /**
     * PO订单主表信息 分页查询
     *
     * @param wmsPOMaster
     * @return
     */
    public static String packHqlWmsPOMaster(WmsPOMaster wmsPOMaster) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsPOMaster.getOrderNo(), "orderNo", result);
        HqlPack.getStringLikerPack(wmsPOMaster.getPoType(), "poType", result);
        HqlPack.getNumEqualPack(wmsPOMaster.getPoStatus(), "poStatus", result);
        HqlPack.getStringLikerPack(wmsPOMaster.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(wmsPOMaster.getSrc(), "src", result);
        HqlPack.getNumEqualPack(wmsPOMaster.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(wmsPOMaster.getIsDeleted(), "isDeleted", result);

        return result.toString();
    }

    /**
     * 物流路线子表查询条件封装
     *
     * @param routingCode
     * @return
     */
    public static String packHqlWmsRoutingChildren(String routingCode) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(routingCode, "routingCode", result);

        HqlPack.getNumEqualPack(CommonEnumUtil.IS_VAILD.VAILD.getValue(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                "isDeleted", result);
        return result.toString();
    }


    /**
     * 物流路线主表查询条件封装
     *
     * @param wmsRoutingMaster
     * @return
     */
    public static String packHqlWmsRoutingMaster(WmsRoutingMaster wmsRoutingMaster) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsRoutingMaster.getRoutingCode(), "routingCode", result);
        HqlPack.getStringLikerPack(wmsRoutingMaster.getRoutingName(), "routingName", result);

        HqlPack.getStringEqualPack(wmsRoutingMaster.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(wmsRoutingMaster.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                "isDeleted", result);
        return result.toString();
    }

    /**
     * 物料查询条件封装
     *
     * @param wmsPart
     * @return
     */
    public static String packHqlWmsPart(WmsPart wmsPart) {
        StringBuffer result = new StringBuffer();

        HqlPack.getStringLikerPack(wmsPart.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsPart.getPartName(), "partName", result);
        HqlPack.timeBuilder(wmsPart.getCreateDateTimeStart(), wmsPart.getCreateDateTimeEnd(), "createDatetime", result, true);
        HqlPack.getStringLikerPack(wmsPart.getPartSpec(), "partSpec", result);
        HqlPack.getStringLikerPack(wmsPart.getPartType(), "partType", result);

        HqlPack.getStringEqualPack(wmsPart.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(wmsPart.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                "isDeleted", result);

        return result.toString();
    }

    /**
     * 抽点比例信息 分页查询
     *
     * @param wmsIbCheckPlan
     * @return
     */
    public static String packHqlWmsIbCheckPlan(WmsIbCheckPlan wmsIbCheckPlan) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsIbCheckPlan.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsIbCheckPlan.getPartNameRdd(), "partNameRdd", result);
        HqlPack.getNumEqualPack(wmsIbCheckPlan.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 库位物料信息 分页查询
     *
     * @param wmsLocatePart
     * @return
     */
    public static String packHqlWmsLocatePart(WmsLocatePart wmsLocatePart) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsLocatePart.getLocateNo(), "locateNo", result);
        HqlPack.getStringLikerPack(wmsLocatePart.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsLocatePart.getPartName(), "partName", result);
        HqlPack.getNumEqualPack(wmsLocatePart.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 库位信息 分页查询
     *
     * @param wmsLocate
     * @return
     */
    public static String packHqlWmsLocates(WmsLocate wmsLocate) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsLocate.getLocateNo(), "locateNo", result);
        HqlPack.getStringLikerPack(wmsLocate.getLocateName(), "locateName", result);
        HqlPack.getStringLikerPack(wmsLocate.getLocateType(), "locateType", result);
        HqlPack.getStringLikerPack(wmsLocate.getWhNo(), "whNo", result);
        HqlPack.getStringLikerPack(wmsLocate.getZoneNo(), "zoneNo", result);
        HqlPack.getNumEqualPack(wmsLocate.getIsValid(), "isValid", result);

        return result.toString();
    }

    /**
     * 工厂仓库模糊分页查询
     *
     * @param wareHouse
     * @return
     */
    public static String packHqlFactoryStore(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();

        // 部门名称
        HqlPack.getStringLikerPack(wareHouse.getCode(), "code", result);
        // 部门代码
        HqlPack.getStringLikerPack(wareHouse.getName(), "name", result);

        return result.toString();
    }

    public static String packHqlWmsButton(WmsButton wmsButton) {
        StringBuffer result = new StringBuffer();

        // 功能名称（name）
        HqlPack.getStringLikerPack(wmsButton.getName(), "name", result);
        // 前端实现（ui）
        HqlPack.getStringLikerPack(wmsButton.getUi(), "ui", result);
        // URI权限规则（bs）
        HqlPack.getStringLikerPack(wmsButton.getBs(), "bs", result);

        return result.toString();
    }

    /**
     * 元数据信息 分页查询
     *
     * @param wmsObject
     * @return
     */
    public static String packHqlWmsObject(WmsObject wmsObject) {
        StringBuffer result = new StringBuffer();

        // 编码
        HqlPack.getStringLikerPack(wmsObject.getCode(), "code", result);
        // 名称
        HqlPack.getStringEqualPack(wmsObject.getName(), "name", result);
        // 数据主表
        HqlPack.getStringEqualPack(wmsObject.getTableName(), "tableName", result);
        // 自定义业务拦截
        HqlPack.getStringEqualPack(wmsObject.getBizIntercept(), "bizIntercept", result);
        return result.toString();
    }

    /**
     * 元数据字段分页查询
     *
     * @param wmsField
     * @return
     */
    public static String packHqlWmsField(WmsField wmsField) {
        StringBuffer result = new StringBuffer();
        // 编码
        HqlPack.getStringLikerPack(wmsField.getObjectCode(), "objectCode", result);
        HqlPack.getStringLikerPack(wmsField.getTableName(), "tableName", result);
        return result.toString();
    }


    /**
     * 交易类型信息 分页查询
     *
     * @param wmsTransType
     * @return
     */
    public static String packHqlWmsTransType(WmsTransType wmsTransType) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringLikerPack(wmsTransType.getTransTypeCode(), "transTypeCode", result);
        HqlPack.getStringLikerPack(wmsTransType.getTransTypeName(), "transTypeName", result);
        HqlPack.getStringLikerPack(wmsTransType.getProgCode(), "progCode", result);
        HqlPack.getStringLikerPack(wmsTransType.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(wmsTransType.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(wmsTransType.getIsDeleted(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 库存交易记录信息 分页查询
     *
     * @param wmsTrans
     * @return
     */
    public static String packHqlWmsTrans(WmsTrans wmsTrans) {
        StringBuffer result = new StringBuffer();

        //查询参数封装
        HqlPack.getStringEqualPack(wmsTrans.getTransCode(), "transCode", result);
        HqlPack.getStringEqualPack(wmsTrans.getSn(), "sn", result);
        HqlPack.timeBuilder(wmsTrans.getCreateDatetime(), null, "createDatetime", result, true);
        return result.toString();
    }

    /**
     * 仓库分页查询条件
     *
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouse(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wareHouse.getAddress(), "address", result);
        HqlPack.getStringLikerPack(wareHouse.getCode(), "code", result);
        HqlPack.getStringLikerPack(wareHouse.getName(), "name", result);
        HqlPack.getNumEqualPack(wareHouse.getIsValid(), "isValid", result);
        HqlPack.getStringEqualPack(wareHouse.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 供应商分页查询
     *
     * @param basVendor
     * @return
     */
    public static String packHqlBasVendor(BasVendor basVendor) {
        StringBuffer result = new StringBuffer();

        HqlPack.getStringLikerPack(basVendor.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(basVendor.getVendorName(), "vendorName", result);
        HqlPack.getStringLikerPack(basVendor.getVendorOwner(), "vendorOwner", result);
        HqlPack.getStringLikerPack(basVendor.getVendorDesc(), "vendorDesc", result);
        HqlPack.getStringLikerPack(basVendor.getVendorAddr(), "vendorAddr", result);
        HqlPack.getStringLikerPack(basVendor.getVendorEmail(), "vendorEmail", result);
        HqlPack.getStringEqualPack(basVendor.getOrganizeCode(), "organizeCode", result);
        if (basVendor.getIsAsn() != null) {
            HqlPack.getStringLikerPack(basVendor.getIsAsn().toString(), "isAsn", result);
        }
        HqlPack.getNumEqualPack(basVendor.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 作业类型分页查询
     *
     * @param wmsOpType
     * @return
     */
    public static String packHqlWmsOpType(WmsOpType wmsOpType) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringLikerPack(wmsOpType.getOpTypeName(), "opTypeName", result);
        if (wmsOpType.getSeq() != null) {
            HqlPack.getStringLikerPack(wmsOpType.getSeq().toString(), "seq", result);
        }
        HqlPack.getStringLikerPack(wmsOpType.getProCode(), "proCode", result);
        HqlPack.getNumEqualPack(wmsOpType.getIsValid(), "isValid", result);
        HqlPack.getStringEqualPack(wmsOpType.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 仓库唯一性校验查询条件【用于添加和修改】
     *
     * @param wareHouse
     * @return
     */
    public static String packHqlWareHouseUnique(WareHouse wareHouse) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(wareHouse.getName(), "name", result);
        HqlPack.getStringEqualPack(wareHouse.getCode(), "code", result);
        HqlPack.getNumNOEqualPack(wareHouse.getId(), "id", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 供应商唯一性校验查询条件【用于添加和修改】
     *
     * @param basVendor
     * @return
     */
    public static String packHqlBasVendorUnique(BasVendor basVendor) {
        StringBuffer result = new StringBuffer();
        if (basVendor.getId() != null) {
            HqlPack.getNumNOEqualPack(basVendor.getId(), "id", result);
        }
        HqlPack.getStringEqualPack(basVendor.getVendorNo(), "vendorNo", result);
        HqlPack.getStringEqualPack(basVendor.getVendorName(), "vendorName", result);
        HqlPack.getStringEqualPack(basVendor.getVendorDesc(), "vendorDesc", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    public static String packHqlWmsOpTypeUnique(WmsOpType wmsOpType) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringEqualPack(wmsOpType.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringEqualPack(wmsOpType.getOpTypeName(), "opTypeName", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 存储区信息 查询条件封装
     *
     * @param wmsZones
     * @return
     */
    public static String packHqlWmsZones(WmsZones wmsZones) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsZones.getIsValid(), "isValid", result);
        //仓库代码
        HqlPack.getStringLikerPack(wmsZones.getWhNo(), "whNo", result);
        //库存地代码
        HqlPack.getStringLikerPack(wmsZones.getAreaNo(), "areaNo", result);
        //存储区代码
        HqlPack.getStringLikerPack(wmsZones.getZoneNo(), "zoneNo", result);
        return result.toString();
    }

    /**
     * 客户信息 查询条件封装
     *
     * @param basCustomer
     * @return
     */
    public static String packHqlBasCustomer(BasCustomer basCustomer) {
        StringBuffer result = new StringBuffer();

        //客户编号
        HqlPack.getStringLikerPack(basCustomer.getCustNo(), "custNo", result);
        //客户简称
        HqlPack.getStringLikerPack(basCustomer.getCustName(), "custName", result);
        //客户全称
        HqlPack.getStringLikerPack(basCustomer.getCustDesc(), "custDesc", result);

        HqlPack.getStringEqualPack(basCustomer.getOrganizeCode(), "organizeCode", result);
        HqlPack.getNumEqualPack(basCustomer.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(),
                "isDeleted", result);
        return result.toString();
    }

    /**
     * 客户发往地信息 查询条件封装
     *
     * @param wmsShippingFlag
     * @return
     */
    public static String packHqlWmsShippingFlag(WmsShippingFlag wmsShippingFlag) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsShippingFlag.getIsValid(), "isValid", result);
        //供应商编号
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagNo(), "flagNo", result);
        //供应商简称
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagName(), "flagName", result);
        //供应商全称
        HqlPack.getStringLikerPack(wmsShippingFlag.getFlagDesc(), "flagDesc", result);
        return result.toString();
    }

    /**
     * ASN订单分页查询条件
     *
     * @param wmsASNMaster
     * @return
     */
    public static String packHqlWmsASNMaster(WmsASNMaster wmsASNMaster) {
        StringBuffer result = new StringBuffer();

        HqlPack.getStringLikerPack(wmsASNMaster.getOrderNo(), "orderNo", result);
        HqlPack.getStringLikerPack(wmsASNMaster.getAsnType(), "type", result);
        HqlPack.getStringLikerPack(wmsASNMaster.getAsnStatus().toString(), "status", result);
        HqlPack.getStringLikerPack(wmsASNMaster.getVendorNo(), "vendorNo", result);
        HqlPack.getStringLikerPack(wmsASNMaster.getVersion(), "version", result);
        HqlPack.getStringLikerPack(wmsASNMaster.getSrc(), "src", result);
        HqlPack.getStringLikerPack(wmsASNMaster.getPoNo(), "poNo", result);
        //有效性
        HqlPack.getNumEqualPack(wmsASNMaster.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        HqlPack.getStringEqualPack(wmsASNMaster.getOrganizeCode(), "organizeCode", result);
        return result.toString();
    }

    /**
     * 产品发运信息 查询条件封装
     *
     * @param wmsShopping
     * @return
     */
    public static String packHqlWmsShipping(WmsShopping wmsShopping) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsShopping.getIsValid(), "isValid", result);
        //发运单号
        HqlPack.getStringLikerPack(wmsShopping.getOrderNo(), "orderNo", result);
        //客户编码
        HqlPack.getStringLikerPack(wmsShopping.getCustNo(), "custNo", result);
        //条码
        HqlPack.getStringLikerPack(wmsShopping.getPartNo(), "partNo", result);
        //发运状态
        HqlPack.getStringEqualPack(wmsShopping.getOrderStatus().toString(), "orderStatus", result);
        return result.toString();
    }

    /**
     * 产品发运信息 查询条件封装
     *
     * @param wmsCheckFactRecord
     * @return
     */
    public static String packHqlWmsCheckFactRecord(WmsCheckFactRecord wmsCheckFactRecord) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsCheckFactRecord.getIsValid(), "isValid", result);
        //采购单号
        HqlPack.getStringLikerPack(wmsCheckFactRecord.getPoNo(), "poNo", result);
        //ASN单号
        HqlPack.getStringLikerPack(wmsCheckFactRecord.getAsnNo(), "asnNo", result);
        //条码
        HqlPack.getStringLikerPack(wmsCheckFactRecord.getSn(), "getSn", result);
        //物料编码
        HqlPack.getStringEqualPack(wmsCheckFactRecord.getPartNo(), "partNo", result);
        //供应商编号
        HqlPack.getStringEqualPack(wmsCheckFactRecord.getVendorNo(), "vendorNo", result);
        return result.toString();
    }

    /**
     * 明细表唯一性查询
     *
     * @return
     */
    public static String packHqlwmsASNMasterDetailsUnique(WmsASNMasterDetails wmsASNMasterDetails) {
        StringBuffer result = new StringBuffer();
        //有效性
        HqlPack.getNumEqualPack(wmsASNMasterDetails.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    public static String packHqlWmsASNMasterDetails(WmsASNMasterDetails wmsASNMasterDetails) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getOrderNo(), "orderNo", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getItem(), "item", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getPartNameRdd(), "partNameRdd", result);
        HqlPack.getNumLikerPack(wmsASNMasterDetails.getQty(), "qty", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getPoItem(), "poItem", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getUnit(), "unit", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getZDate(), "zDate", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getZTime(), "zTime", result);
        HqlPack.getNumLikerPack(wmsASNMasterDetails.getItemStatus(), "itemStatus", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getPackAge(), "packAge", result);
        HqlPack.getNumLikerPack(wmsASNMasterDetails.getIsFree(), "isFree", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getDock(), "dock", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getSnOneBarCode(), "snOneBarCode", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getSnTwoBarCode(), "snTwoBarCode", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getGroupNo(), "groupNo", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getErpWhNo(), "erpWhNo", result);
        HqlPack.getStringLikerPack(wmsASNMasterDetails.getVendorLotNo(), "vendorLotNo", result);

        //有效性
        HqlPack.getNumEqualPack(wmsASNMasterDetails.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(CommonEnumUtil.TRUE_OR_FALSE.FALSE.getValue(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 产品入库信息 条件封装
     *
     * @param wmsFGInStock
     * @return
     */
    public static String packHqlWmsFGInStock(WmsFGInStock wmsFGInStock) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsFGInStock.getOrderNo(), "orderNo", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getWoNo(), "woNo", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getPartNo(), "partNo", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getPartNameRdd(), "partNameRdd", result);
        HqlPack.getNumEqualPackDouble(wmsFGInStock.getQty(), "qty", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getUnit(), "unit", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getSn(), "sn", result);
        HqlPack.getNumEqualPack(wmsFGInStock.getOrderStatus(), "orderStatus", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getReMark(), "reMark", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getSrc(), "src", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getErpWhNo(), "erpWhno", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getLineNo(), "lineNo", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getWhNo(), "whNo", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getCustNo(), "custNo", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getShippingFlag(), "shippingFlag", result);
        HqlPack.getStringLikerPack(wmsFGInStock.getMfgLogNo(), "mfgLogNo", result);
        HqlPack.getNumEqualPack(wmsFGInStock.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(wmsFGInStock.getIsDeleted(), "isDeleted", result);
        return result.toString();
    }

    /**
     * 作业任务信息条件封装
     *
     * @param wmsTaskInfo
     * @return
     */
    public static String packHqlWmsTaskInfo(WmsTaskInfo wmsTaskInfo) {
        StringBuffer result = new StringBuffer();
        HqlPack.getStringLikerPack(wmsTaskInfo.getMoveNo(), "moveNo", result);
        HqlPack.getStringLikerPack(wmsTaskInfo.getUserNo(), "userNo", result);
        HqlPack.getStringLikerPack(wmsTaskInfo.getOpTypeCode(), "opTypeCode", result);
        HqlPack.getStringLikerPack(wmsTaskInfo.getReMark(), "reMark", result);
        HqlPack.getNumEqualPack(wmsTaskInfo.getTaskStatus(), "taskStatus", result);
        HqlPack.getNumEqualPack(wmsTaskInfo.getIsValid(), "isValid", result);
        HqlPack.getNumEqualPack(wmsTaskInfo.getIsDeleted(), "isDeleted", result);
        return result.toString();
    }
}
